"use strict";

exports.__esModule = true;
exports.enableIf = exports.select = exports.adjustFieldTypeSimple = exports.adjustFieldType = exports.makeStmt = exports.makeExpr = exports.transform = exports.babelBridge = exports.checkpoint = exports.checkpointLazy = exports.wrap = exports.UpdateOpts = exports.Opts = exports.find = exports.Subst = exports.OutputStream = exports.NoInput = exports.AutoArrStream = exports.AutoStream = exports.LevelArrStream = exports.LevelStream = exports.LookaheadStream = exports.LookaheadArrStream = exports.toks = exports.Output = exports.Lookahead = exports.ArrayLookahead = exports.ExtIterator = undefined;
exports.optsScope = optsScope;
exports.optsScopeLift = optsScopeLift;
exports.setOpts = setOpts;
exports.Level = Level;
exports.WithPeel = WithPeel;
exports.Template = Template;
exports.Stream = Stream;
exports.lookahead = lookahead;
exports.levels = levels;
exports.auto = auto;
exports.output = output;
exports.skip = skip;
exports.setType = setType;
exports.setPos = setPos;
exports.completeSubst = completeSubst;
exports.toArray = toArray;
exports.result = result;
exports.tillLevel = tillLevel;
exports.toBlockBody = toBlockBody;
exports.inBlockBody = inBlockBody;
exports.hasAnnot = hasAnnot;
exports.clone = clone;
exports.till = till;
exports.concat = concat;
exports.share = share;
exports.tee = tee;
exports.makeExprPass = makeExprPass;
exports.removeEmptyBlocks = removeEmptyBlocks;
exports.cons = cons;
exports.la = la;

var _ramda = require("ramda");

var R = _interopRequireWildcard(_ramda);

var _assert = require("assert");

var assert = _interopRequireWildcard(_assert);

var _core = require("./core");

var _babelTypes = require("babel-types");

var T = _interopRequireWildcard(_babelTypes);

var _babylon = require("babylon");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var BROWSER_DEBUG = typeof window !== "undefined" && window.chrome;
var _opts = {};

function optsScope(fun) {
  var save = _opts;
  try {
    return fun();
  } finally {
    _opts = save;
  }
}

function optsScopeLift(fun) {
  return function () {
    var save = _opts;
    try {
      return fun.apply(this, arguments);
    } finally {
      _opts = save;
    }
  };
}

function setOpts(opts) {
  _opts = opts;
}

/**
 * adds `take` function to ES6 iterators interface
 * children classes may implement one of `take` or `next` methods
 */

var ExtIterator = exports.ExtIterator = function () {
  ExtIterator.prototype[Symbol.iterator] = function () {
    return this;
  };
  /**
   * ES6 Iterator interface `next`
   */


  ExtIterator.prototype.next = function next(v) {
    var c = this.take(v);
    return { value: c, done: c == null };
  };
  /**
   * same as `next` but returns either next value or null if done
   */


  ExtIterator.prototype.take = function take(v) {
    var c = this.next(v);
    return c.done ? null : c.value;
  };

  function ExtIterator(cont) {
    _classCallCheck(this, ExtIterator);

    this._cont = cont;
  }

  return ExtIterator;
}();

var ArrayLookahead = exports.ArrayLookahead = function (_ExtIterator) {
  _inherits(ArrayLookahead, _ExtIterator);

  function ArrayLookahead(cont) {
    _classCallCheck(this, ArrayLookahead);

    var _this = _possibleConstructorReturn(this, _ExtIterator.call(this, cont));

    assert.ok(cont.length > 0, "input iterator should be not-empty");
    _this._x = 0;
    _this.first = cont[0];
    _this.opts = _this.first.value && _this.first.value.opts || _opts;
    return _this;
  }

  ArrayLookahead.prototype.next = function next(v) {
    var c = this._cont[this._x++];
    if (c != null && c.value != null && c.value.opts != null) this.opts = c.value.opts;
    return { value: c, done: c == null };
  };

  ArrayLookahead.prototype.take = function take(v) {
    var c = this._cont[this._x++];
    if (c != null && c.opts != null) this.opts = c.opts;
    return c;
  };
  //  last() {
  //    return this._cont[this._x-1]
  //  }


  ArrayLookahead.prototype.cur = function cur() {
    return this._cont[this._x];
  };

  return ArrayLookahead;
}(ExtIterator);

/** 
 * iterators wrapper keeping a single element lookahead, which may be accessed
 * with `cur` method
 *
 * the iterator may be shared
 */


var Lookahead = exports.Lookahead = function (_ExtIterator2) {
  _inherits(Lookahead, _ExtIterator2);

  function Lookahead(cont) {
    _classCallCheck(this, Lookahead);

    var _this2 = _possibleConstructorReturn(this, _ExtIterator2.call(this, cont));

    _this2._inner = cont[Symbol.iterator]();
    var i = _this2._inner.next();
    assert.ok(!i.done, "input iterator should be not-empty");
    _this2.first = i.value;
    _this2.opts = _this2.first.value && _this2.first.value.opts || _opts;
    _this2._cur = i;
    //    this._last = null
    return _this2;
  }

  Lookahead.prototype.next = function next(v) {
    var cur = this._cur;
    //    this._last = cur.value
    if (!cur.done) {
      if (cur.value.value != null && cur.value.value.opts != null) this.opts = cur.value.value.opts;
      this._cur = this._inner.next(v);
    }
    return cur;
  };
  //  last() { return this._last; }


  Lookahead.prototype.take = function take(v) {
    var cur = /*this._last =*/this._cur;
    if (cur.done) return null;
    if (cur.value.opts != null) this.opts = cur.value.opts;
    this._cur = this._inner.next(v);
    return cur.value;
  };

  Lookahead.prototype.cur = function cur() {
    return this._cur.done ? undefined : this._cur.value;
  };

  return Lookahead;
}(ExtIterator);

var ctrlTok = Symbol("ctrlTok");
var ctrlTokGen = Symbol("ctrlTokGen");
var storedTok = Symbol("storedTok");

var Output = exports.Output = Super => function (_Super) {
  _inherits(Output, _Super);

  function Output(cont) {
    _classCallCheck(this, Output);

    var _this3 = _possibleConstructorReturn(this, _Super.call(this, cont));

    _this3._stack = [];
    return _this3;
  }

  Output.prototype.valCtor = function valCtor(pos, type, value) {
    var node = null;
    if (value == null) {
      value = {};
      if (type != null && typeof type !== "symbol") {
        if (type.node != null) {
          value = type;
          node = value.node;
          type = null;
        } else if (type.type != null) {
          node = type;
          value = { node };
          type = null;
        }
      }
    } else node = value.node;
    if (type == null) {
      if (value != null && value.typeInfo != null) {
        type = value.typeInfo.sym;
      } else if (node != null && node.type != null) {
        type = _core.Tag[node.type];
      } else {
        if ((0, _core.symInfo)(pos) === "ctrl") type = pos;
      }
    }
    assert.ok(type, "couldn't guess type");
    if (node == null) {
      value.node = node = type === _core.Tag.Array ? [] : type === _core.Tag.Null ? null : {};
    }
    if (!value.opts) value.opts = this.opts;
    //    value.typeInfo = symInfo(type)
    return [pos, type, value];
  };

  Output.prototype.toks = function* toks(pos, node) {
    yield* _toks(pos, node);
  };

  Output.prototype.enter = function enter(pos, type, value) {
    var _valCtor = this.valCtor(pos, type, value);

    pos = _valCtor[0];
    type = _valCtor[1];
    value = _valCtor[2];

    this._stack.unshift({ $: storedTok,
      tok: { enter: false, leave: true,
        pos: pos, type: type, value: value } });
    return { enter: true, leave: false, type, pos, value };
  };

  Output.prototype.tok = function tok(pos, type, value) {
    var _valCtor2 = this.valCtor(pos, type, value);

    pos = _valCtor2[0];
    type = _valCtor2[1];
    value = _valCtor2[2];

    return { enter: true, leave: true, type, pos, value };
  };

  Output.prototype.leave = function* leave() {
    var f = void 0;
    while (f = this._stack.shift()) {
      switch (f.$) {
        case ctrlTok:
          f.run(this);
          break;
        case ctrlTokGen:
          yield* f.run(this);
          break;
        default:
          yield f.tok;
          return f.tok;
      }
    }
  };

  Output.prototype.label = function label() {
    var pos = this._stack.length;
    var t = this;
    return function* () {
      var sub = t._stack.splice(0, t._stack.length - pos);
      for (var i of sub) {
        switch (i.$) {
          case ctrlTok:
            i.run(t);
            break;
          case ctrlTokGen:
            yield* i.run(t);
            break;
          default:
            yield i.tok;
        }
      }
    };
  };

  return Output;
}(Super);

function Level(Super) {
  function* _one(t) {
    var c = t.cur();
    if (c == null || !c.enter) return null;
    var exit = t.level;
    var i = void 0;
    for (i of t) {
      yield i;
      if (exit >= t.level) return i;
    }
    return i;
  }
  function* _sub(t) {
    var c = t.cur();
    if (c == null || !c.enter) return null;
    var exit = t.level;
    var i = void 0;
    for (i of t) {
      yield i;
      if (exit >= t.level) {
        var _c = t.cur();
        if (_c == null || !_c.enter || exit > t.level) return i;
      }
    }
    return i;
  }
  return function (_Super2) {
    _inherits(Level, _Super2);

    function Level(cont) {
      _classCallCheck(this, Level);

      var _this4 = _possibleConstructorReturn(this, _Super2.call(this, cont));

      _this4.level = 0;
      return _this4;
    }

    Level.prototype.next = function next(v) {
      var c = _Super2.prototype.next.call(this, v);
      if (c.done) return c;
      var t = c.value;
      if (t.enter) this.level++;
      if (t.leave) this.level--;
      return c;
    };

    Level.prototype.take = function take(v) {
      var c = _Super2.prototype.take.call(this, v);
      if (c == null) return c;
      if (c.enter) this.level++;
      if (c.leave) this.level--;
      return c;
    };

    Level.prototype.one = function one() {
      return _one(this);
    };

    Level.prototype.sub = function sub() {
      return _sub(this);
    };

    Level.prototype.curLev = function curLev() {
      var v = this.cur();
      if (!v || !v.enter) return null;
      return v;
    };

    Level.prototype.untilPos = function* untilPos(pos) {
      var i;
      while ((i = this.curLev()) != null && i.pos !== pos) {
        yield* _one(this);
      }return i;
    };

    Level.prototype.findPos = function* findPos(pos) {
      var i = yield* this.untilPos(pos);
      if (i != null) this.take();
      return i;
    };

    Level.prototype.toPos = function* toPos(pos) {
      var p = yield* this.findPos(pos);
      assert.ok(p);
      yield p;
      return p;
    };

    return Level;
  }(Super);
}

function WithPeel(Super) {
  var copyTag = { $: ctrlTokGen, *run(t) {
      yield t.take();
    }, t: "copy" };
  // means we are to skip next tag from input because it is in the stack already
  var skipTag = { $: ctrlTok, run(t) {
      t.take();
    }, t: "skip" };
  // virtual close (already closed in token)
  var vCloseTag = { $: ctrlTok, run() {}, t: "close" };
  return function (_Super3) {
    _inherits(WithPeel, _Super3);

    function WithPeel(cont) {
      _classCallCheck(this, WithPeel);

      return _possibleConstructorReturn(this, _Super3.call(this, cont));
    }

    WithPeel.prototype.peel = function peel(i) {
      if (i == null) i = this.take();
      assert.ok(i.enter);
      var res = this.enter(i.pos, i.type, i.value);
      this._stack.unshift(i.leave ? vCloseTag : skipTag);
      return res;
    };

    WithPeel.prototype.peelTo = function* peelTo(pos) {
      assert.notEqual(this._stack[0], vCloseTag);
      var i = yield* this.findPos(pos);
      assert.ok(i);
      yield this.peel(i);
      return i;
    };

    WithPeel.prototype.peelOpt = function peelOpt() {
      var v = this.cur();
      if (!v || !v.enter) return null;
      return this.peel();
    };

    WithPeel.prototype.one = function* one() {
      if (this._stack[0] !== vCloseTag) return yield* _Super3.prototype.one.call(this);
      return null;
    };

    WithPeel.prototype.sub = function* sub() {
      if (this._stack[0] !== vCloseTag) return yield* _Super3.prototype.sub.call(this);
      return null;
    };

    WithPeel.prototype.findPos = function* findPos(pos) {
      if (this._stack[0] !== vCloseTag) return yield* _Super3.prototype.findPos.call(this, pos);
      return null;
    };

    WithPeel.prototype.copy = function* copy(i) {
      yield this.peel(i);
      yield* this.sub();
      yield* this.leave();
    };

    WithPeel.prototype.close = function close(i) {
      var j = this.take();
      assert.equal(i.value, j.value);
    };

    return WithPeel;
  }(Super);
}

var memo = new Map();

function* _toks(pos, s) {
  if (Array.isArray(s)) yield* clone(s);
  if (s.substr != null) {
    var r = memo.get(s);
    if (r == null) {
      var mod = null;
      var js = s;
      switch (s[0]) {
        case "=": // expression
        case "*": // list of statements
        case ">":
          // var declarator
          mod = s[0];
          js = s.slice(1);
      }
      var b = (0, _babylon.parse)(js, { sourceType: "module", plugins: ["dynamicImport"] });
      assert.equal(b.type, "File");
      assert.equal(b.program.type, "Program");
      if (!mod === "*") assert.equal(b.program.body.length, 1);
      switch (mod) {
        case "=":
          assert.equal(b.program.body[0].type, "ExpressionStatement");
          r = b.program.body[0].expression;
          break;
        case ">":
          assert.equal(b.program.body[0].type, "ExpressionStatement");
          var _s = b.program.body[0].expression;
          assert.equal(_s.type, "AssignmentExpression");
          r = T.variableDeclarator(_s.left, _s.right);
          break;
        case "*":
          break;
        default:
          r = b.program.body[0];
      }
      if (mod === "=" || mod === ">") {} else if (mod === "*") {
        r = b.program.body;
      } else {
        r = b.program.body[0];
      }
      memo.set(s, r);
    }
    s = r;
  }
  if (Array.isArray(s)) {
    for (var i of s) {
      yield* clone((0, _core.produce)(i, pos));
    }
  } else yield* clone((0, _core.produce)(s, pos));
}

exports.toks = _toks;
function Template(Super) {
  var templateTok = { $: ctrlTokGen,
    *run(t) {
      yield* t._tstack.shift();
    } };
  return function (_Super4) {
    _inherits(Template, _Super4);

    function Template(cont) {
      _classCallCheck(this, Template);

      var _this6 = _possibleConstructorReturn(this, _Super4.call(this, cont));

      _this6._tstack = [];
      return _this6;
    }

    Template.prototype.template = function template(pos, node) {
      if (node.substr != null) node = toArray(_toks(pos, node));
      this._stack.unshift(templateTok);
      this._tstack.unshift(node);
    };

    Template.prototype.open = function* open() {
      var arr = this._tstack[0];
      while (arr.length) {
        var f = arr.shift();
        if (f.enter) {
          switch (f.type) {
            case _core.Tag.ExpressionStatement:
              var n = arr[0];
              if (n != null && n.type === _core.Tag.Identifier && n.value.node.name === "$$") {
                while (arr.length && arr.shift().value !== f.value) {}
                return f.pos;
              }
              break;
            case _core.Tag.Identifier:
              if (f.type === _core.Tag.Identifier) {
                var _n = f.value.node.name;
                if (_n === "$$" || _n === "$E") {
                  while (arr.length && arr.shift().value !== f.value) {}
                  return f.pos;
                }
              }
              break;
          }
        }
        yield f;
      }
      throw new Error("next placeholder is not found");
    };

    return Template;
  }(Super);
}

function Stream(opts) {
  if (opts == null) opts = {};
  var Iterator = opts.input || opts.level || opts.peel ? opts.arr ? ArrayLookahead : Lookahead : NoInput;
  if (opts.peel || opts.level) Iterator = Level(Iterator);
  if (opts.template || opts.output || opts.peel) Iterator = Output(Iterator);
  if (opts.peel) Iterator = WithPeel(Iterator);
  if (opts.template) Iterator = Template(Iterator);
  return Iterator;
}

var LookaheadArrStream = exports.LookaheadArrStream = Stream({ arr: true, input: true });
var LookaheadStream = exports.LookaheadStream = Stream({ input: true });
function lookahead(s) {
  // return Array.isArray(s) ? new LookaheadArrStream(s) : new LookaheadStream(s)
  return new LookaheadStream(s);
}

var LevelStream = exports.LevelStream = Stream({ level: true });
var LevelArrStream = exports.LevelArrStream = Stream({ level: true, arr: true });
function levels(s) {
  //  return Array.isArray(s) ? new LevelStream(s) : new LevelArrStream(s)
  return new LevelStream(s);
}

var AutoStream = exports.AutoStream = Stream({ peel: true, template: true });
var AutoArrStream = exports.AutoArrStream = Stream({ peel: true, template: true, arr: true });
function auto(s) {
  //  return Array.isArray(s) ? new AutoArrStream(s) : new AutoStream(s)
  return new AutoStream(s);
}

var NoInput = exports.NoInput = function NoInput() {
  _classCallCheck(this, NoInput);
};

var OutputStream = exports.OutputStream = Template(Output(NoInput));
function output(s) {
  return new OutputStream(s);
}

function skip(s) {
  var iter = s[Symbol.iterator]();
  var i = void 0;
  for (; !(i = iter.next()).done;) {}
  return i.value;
}

/**
  * modifies token replacing its `type` field
  */
function setType(i, type) {
  return { enter: i.enter, leave: i.leave, type, pos: i.pos, value: i.value };
}

/**
  * modifies token replacing its `pos` field
  */
function setPos(i, pos) {
  return { enter: i.enter, leave: i.leave, type: i.type, pos, value: i.value };
}

var Subst = exports.Subst = (0, _core.symbol)("Subst", "ctrl");

function* completeSubst(s) {
  var sl = auto(s);
  function* subst(pos) {
    for (var i of sl.sub()) {
      if (i.type === Subst) {
        if (i.enter) yield* subst(pos);
      } else {
        yield sl.peel(setPos(i, pos));
        yield* walk();
        yield* sl.leave();
      }
    }
  }
  function* walk() {
    for (var i of sl.sub()) {
      if (i.type === Subst) {
        if (i.enter) {
          assert.ok(!i.leave);
          yield* subst(i.pos);
        }
      } else yield i;
    }
  }
  yield* walk();
}

function toArray(s) {
  return Array.isArray(s) ? s : Array.from(s);
}

function result(s, buf) {
  var iter = s[Symbol.iterator]();
  var i = void 0;
  for (; !(i = iter.next()).done;) {
    buf.push(i.value);
  }return i.value;
}

ExtIterator.prototype.tillLevel = function (level) {
  return tillLevel(level, this);
};
/**
 * values until leaving specified level
 */
function* tillLevel(level, s) {
  for (var i of s) {
    yield i;
    if (i.leave && s.level === level) return;
  }
}

function* toBlockBody(s) {
  var lab = s.label();
  var i = s.cur();
  if (i.type === _core.Tag.BlockStatement) {
    s.peel();
    skip(s.peelTo(_core.Tag.body));
    return function* () {
      skip(lab());
    };
  } else {
    yield s.enter(_core.Tag.push, Subst);
    return lab;
  }
}

function* inBlockBody(s, inner) {
  var lab = s.label();
  var i = s.cur();
  if (i.type !== _core.Tag.BlockStatement) {
    yield s.enter(_core.Tag.push, Subst);
    yield* inner;
    yield* lab();
  } else {
    s.peel();
    skip(s.peelTo(_core.Tag.body));
    yield* inner;
    skip(lab());
  }
}

function hasAnnot(node, name) {
  return node.leadingComments && node.leadingComments.length && node.leadingComments.find(v => v.value.trim() === name) !== undefined;
}

function* clone(s) {
  var stack = [];
  for (var i of s) {
    var value = null;
    if (i.enter) {
      stack.push(value = Object.assign({}, i.value));
      var isArray = value.isArray = i.type === _core.Tag.Array;
      if (isArray) value.node = value.node.concat();else if (value.node != null && _core.Tag[i.type] != null) {
        value.node = Object.assign({}, value.node);
        if (value.node.leadingComments != null) value.node.leadingComments = value.node.leadingComments.concat();
        if (value.node.trealingComments != null) value.node.trealingComments = value.node.trealingComments.concat();
      }
    }
    if (i.leave) value = stack.pop();
    yield { enter: i.enter, leave: i.leave, type: i.type, pos: i.pos, value };
  }
}

/**
 * leaves all items un-amended until (and including) an item where 
 * `pred` is true
 */
function* till(pred, s) {
  for (var i of s) {
    yield i;
    if (pred(i)) return i;
  }
  return null;
}
ExtIterator.prototype.till = function (pred) {
  return till(pred, this);
};

var find = exports.find = R.curry(function* find(pred, s) {
  if (pred(s.cur())) return true;
  for (var i of s) {
    if (pred(s.cur())) return true;
    yield i;
  }
});
ExtIterator.prototype.find = function (pred) {
  return find(pred, this);
};

var Opts = exports.Opts = (0, _core.symbol)("Options");
var UpdateOpts = exports.UpdateOpts = (0, _core.symbol)("MergeOptions");

function* concat() {
  for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  for (var i of args) {
    yield* i;
  }
}

/**
 * shares single iterator between several uses
 */
function share(s) {
  var _ref;

  var i = s[Symbol.iterator]();
  return _ref = {}, _ref[Symbol.iterator] = function () {
    return {
      next(v) {
        return i.next(v);
      }
    };
  }, _ref;
}

function saveLast(s) {
  var _res;

  var res = (_res = {}, _res[Symbol.iterator] = function () {
    var i = s[Symbol.iterator]();
    return {
      next(v) {
        return res.cur = i.next(v);
      }
    };
  }, _res);
  return res;
}

var wrap = exports.wrap = R.curry(function* wrap(name, f, s) {
  var babel = _opts.babel;
  var si = auto(s);
  var iter = f(si)[Symbol.iterator]();
  var i = void 0;
  try {
    var j = void 0;
    for (; !(j = iter.next()).done;) {
      i = j.value;
      yield i;
    }
    return j.value;
  } catch (e) {
    if (babel != null) {
      var msg = `${e.message} during ${name}`;
      var node = e.esNode || i && i.value.node; // || si._last
      if (!node || !node.loc && !node._loc) {
        msg += " (the position is approximated)";
        for (var _i of si) {
          node = _i.value.node;
          if (node && (node.loc || node._loc)) throw babel.root.hub.file.buildCodeFrameError(node, msg);
        }
        node = babel.root.node;
      }
      throw babel.root.hub.file.buildCodeFrameError(node, msg);
    }
    throw e;
  }
});

var checkpointLazy = exports.checkpointLazy = R.curry(function* checkpointLazy(name, s) {
  var babel = _opts.babel;
  var iter = s[Symbol.iterator]();
  var last = void 0,
      i = void 0;
  try {
    for (;;) {
      var j = iter.next();
      i = j.value;
      if (j.done) return i;
      if (i.enter && i.value.node != null && i.value.node.loc != null) last = i.value.node;
      yield i;
    }
  } catch (e) {
    if (babel != null) {
      var node = e.esNode || i && i.value.node || last || babel.root.node;
      throw babel.root.hub.file.buildCodeFrameError(node, `${e.message} during ${name}`);
    }
    throw e;
  }
});

var checkpoint = exports.checkpoint = R.curry(function (name, s) {
  return [].concat(_toConsumableArray(checkpointLazy(name, s)));
});

/**
 * babel plugin visitor methods, typically to be applied only to Program node
 */
var babelBridge = exports.babelBridge = R.curry(function babelBridge(pass, path, state) {
  var optSave = _opts;
  _opts = Object.assign({ args: Object.assign({}, state.opts),
    file: Object.assign(state.file.opts),
    babel: { root: path, state } }, _opts);
  pass((0, _core.produce)(path.node));
  _opts = optSave;
});

var transform = exports.transform = R.curry(function transform(pass, ast, opts) {
  var optSave = _opts;
  _opts = opts && { args: {}, file: {}, babel: false };
  try {
    return (0, _core.consume)(pass((0, _core.produce)(ast))).top;
  } finally {
    _opts = optSave;
  }
});

/**
 * copies input stream to output and returns it as array
 */
function* tee(s, buf) {
  if (buf == null) buf = [];
  for (var i of s) {
    yield i;
    buf.push(i);
  }
  return buf;
}

ExtIterator.prototype.error = function (msg, node) {
  if (this._name != null) msg += " during " + this._name;
  var e = new SyntaxError(msg);
  if (node) e.esOrigNode = node;
  if (!node || !node._loc && !node.loc) {
    e.messsage += "(the position is approximated)";
    for (var i of this) {
      node = i.value.node;
      if (node && (node.loc || node._loc)) {
        e.esNode = node;
        return e;
      }
    }
  }
  return e;
};

var makeExpr = exports.makeExpr = (0, _core.symbol)("makeExpr");
var makeStmt = exports.makeStmt = (0, _core.symbol)("makeStmt");

function makeExprPass(s) {
  s = auto(s);
  function* subst(pos) {
    var t = s.peel();
    yield s.enter(pos, t.type, t.value);
    yield* walk();
    yield* s.leave();
    skip(s.leave());
  }
  function* toExpr(pos) {
    var j = s.curLev();
    if (j == null) return;
    if (j.type === makeExpr || j.type === makeStmt) {
      yield s.peel(j);
      yield* toExpr(pos);
      yield s.leave();
    } else {
      var ti = (0, _core.typeInfo)(j);
      if (ti.block) {
        yield s.enter(pos, _core.Tag.CallExpression);
        yield s.enter(_core.Tag.callee, _core.Tag.ArrowFunctionExpression, { node: { params: [] } });
        yield* subst(_core.Tag.body);
        yield* s.leave();
        yield s.tok(_core.Tag.arguments, _core.Tag.Array);
        yield* s.leave();
      } else if (ti.stmt) {
        yield s.enter(pos, _core.Tag.CallExpression);
        var lab = s.label();
        yield s.enter(_core.Tag.callee, _core.Tag.ArrowFunctionExpression, { node: { params: [] } });
        yield s.enter(_core.Tag.body, _core.Tag.BlockStatement);
        yield s.enter(_core.Tag.body, _core.Tag.Array);
        yield* subst(_core.Tag.push);
        yield* lab();
        yield s.tok(_core.Tag.arguments, _core.Tag.Array);
        yield* s.leave();
      } else if (ti.expr) {
        yield* subst(pos);
      } else {
        throw new Error("internal: cannot convert to expression");
      }
    }
  }
  function* toStmt(pos) {
    var j = s.curLev();
    if (j == null) return;
    if (j.type === makeExpr || j.type === makeStmt) {
      yield s.peel(j);
      yield* toStmt(pos);
      yield s.leave();
    } else {
      var ti = (0, _core.symInfo)(j.type);
      if (ti.stmt || ti.block) {
        yield* subst(pos);
      } else {
        yield s.enter(pos, _core.Tag.ExpressionStatement);
        yield* subst(_core.Tag.expression);
        yield* s.leave();
      }
    }
  }
  function* walk(pos) {
    for (var i of s.sub()) {
      switch (i.type) {
        case makeExpr:
          if (i.enter) {
            pos = pos || i.pos;
            yield* toExpr(pos);
          }
          break;
        case makeStmt:
          if (i.enter) {
            pos = pos || i.pos;
            yield* toStmt(pos);
          }
          break;
        default:
          yield i;
      }
    }
  }
  return walk();
}

/**
 * detects if there it is a block statement with only a single result, and removes it
 */
function removeEmptyBlocks(si) {
  var s = auto(si);
  function* walk(sw) {
    for (var i of sw) {
      if (i.enter && i.type === _core.Tag.BlockStatement) {
        var lab = s.label();
        var buf = [s.peel(i)].concat(_toConsumableArray(s.peelTo(_core.Tag.body)));
        if (s.curLev() == null) {
          yield* buf;
          yield* lab();
          continue;
        }
        var fi = i.value.fieldInfo;
        if (fi.expr || fi.stmt) {
          var one = [].concat(_toConsumableArray(walk(s.one())));
          if (s.curLev() != null || fi.expr && fi.block && (0, _core.typeInfo)(one[0]).stmt) {
            yield* buf;
            yield* one;
            yield* walk(s.sub());
            yield* lab();
            continue;
          }
          one[0].pos = one[one.length - 1].pos = i.pos;
          one[0].value.fieldInfo = fi;
          yield* one;
          skip(lab());
        }
        continue;
      }
      yield i;
    }
  }
  return walk(s);
}

function adjustFieldTypeImpl(s) {
  s = auto(s);
  function* subst(pos, i) {
    if (i.leave) {
      yield s.tok(pos, i.type, i.value);
    } else {
      yield s.peel(setPos(i, pos));
      yield* walk();
      yield* s.leave();
    }
  }
  function* walk() {
    for (var i of s.sub()) {
      if (i.enter) {
        var fi = i.value.fieldInfo || {},
            ti = (0, _core.typeInfo)(i);
        if (i.type === _core.Tag.Array && fi.array || fi.stmt && ti.stmt || fi.expr && ti.expr || fi.block && ti.block || i.type === _core.Tag.VariableDeclaration && fi.decl) {
          yield i;
          continue;
        }
        if (i.type === _core.Tag.Array) {
          if (fi.block || fi.stmt) {
            yield s.enter(i.pos, _core.Tag.BlockStatement);
            yield* subst(_core.Tag.body, i);
            yield* s.leave();
          } else if (fi.expr) {
            yield s.enter(i.pos, _core.Tag.SequenceExpression);
            yield* subst(_core.Tag.expressions, i);
            yield* s.leave();
          } else yield i;
          continue;
        }
        if (fi.block) {
          var lab = s.label();
          yield s.enter(i.pos, _core.Tag.BlockStatement);
          yield s.enter(_core.Tag.body, _core.Tag.Array);
          if (ti.expr) {
            if (i.value.result) {
              yield s.enter(_core.Tag.push, _core.Tag.ReturnStatement);
              yield* subst(_core.Tag.argument, i);
            } else {
              yield s.enter(_core.Tag.push, _core.Tag.ExpressionStatement);
              yield* subst(_core.Tag.expression, i);
            }
          } else {
            assert.ok(ti.stmt);
            yield* subst(_core.Tag.push, i);
          }
          yield* lab();
          continue;
        }
        if (fi.stmt && ti.expr) {
          if (i.value.result) {
            yield s.enter(i.pos, _core.Tag.ReturnStatement);
            yield* subst(_core.Tag.argument, i);
            yield* s.leave();
          } else {
            yield s.enter(i.pos, _core.Tag.ExpressionStatement);
            yield* subst(_core.Tag.expression, i);
            yield* s.leave();
          }
          continue;
        }
        if (fi.expr) {
          yield s.enter(i.pos, _core.Tag.CallExpression);
          yield s.enter(_core.Tag.callee, _core.Tag.ArrowFunctionExpression, { node: { params: [], expression: true } });
          if (!ti.block) {
            yield s.enter(_core.Tag.body, _core.Tag.BlockStatement);
            yield s.enter(_core.Tag.body, _core.Tag.Array);
            yield* subst(_core.Tag.push, i);
            yield* s.leave();
            yield* s.leave();
          } else {
            yield* subst(_core.Tag.body, i);
          }
          yield* s.leave();
          yield s.tok(_core.Tag.arguments, _core.Tag.Array);
          yield* s.leave();
          continue;
        }
      }
      yield i;
    }
  }
  return walk();
}

/**
 * for expr/stmt if field type is different to actual value assigned 
 * it tries to change the value's type
 */
var adjustFieldType = exports.adjustFieldType = R.pipe(_core.resetFieldInfo, adjustFieldTypeImpl);

/** like `adjustFieldType` but with some simplifications */
var adjustFieldTypeSimple = exports.adjustFieldTypeSimple = R.pipe(_core.resetFieldInfo, removeEmptyBlocks, adjustFieldTypeImpl);

function* cons(a, s) {
  yield a;
  yield* s;
}

/** 
 * lookahead: returns first element and a stream with same elements
 *    
 *   `Iterable<A> -> [A, Iterable<A>]`  
 */
function la(s) {
  var i = s[Symbol.iterator]();
  var v = i.next().value;
  return [v, cons(v, i)];
}

/** 
 * runs `fn` passing `value.opts` of the stream's first output
 * if its resulting value is positive applies it to the original
 * stream or returns it unchanged
 *
 *     (Opts -> Toks?) -> Toks -> Toks
 */
var select = exports.select = R.curry(function select(fn, s) {
  var _la = la(s),
      h = _la[0],
      sn = _la[1];

  var pass = fn(h.value.opts);
  return pass ? pass(sn) : sn;
});

/** 
 * if `pred` returns true on `opts` field of some first element
 * wraps transforms `s` using `pass` otherwise returns s unchanged
 *
 *     (Opts -> boolean) -> (Toks -> Toks) -> (Toks -> Toks)? -> Toks -> Toks
 */
var enableIf = exports.enableIf = R.curryN(2, function enableIf(pred, t, e, s) {
  if (s == null) {
    if (e != null && typeof e !== "function") {
      s = e;
      e = i => i;
    }
  }
  if (e == null) e = i => i;
  var f = function (s) {
    var _la2 = la(s),
        h = _la2[0],
        sn = _la2[1];

    return pred(h.value.opts) ? t(sn) : e(sn);
  };
  return s != null ? f(s) : f;
});