"use strict";

exports.__esModule = true;

var _core = require("../core");

var _kit = require("../kit");

var Kit = _interopRequireWildcard(_kit);

var _ramda = require("ramda");

var R = _interopRequireWildcard(_ramda);

var _babelTypes = require("babel-types");

var T = _interopRequireWildcard(_babelTypes);

var _assert = require("assert");

var assert = _interopRequireWildcard(_assert);

var _match = require("../match");

var Match = _interopRequireWildcard(_match);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

exports.default = R.pipe(Match.run(`for($$ of $$) $$`), function eagerForOfTransform(si) {
  var s = Kit.auto(si);
  function* walkDecls(decls, txt) {
    var c = decls[0];
    if (c.type === _core.Tag.VariableDeclaration) {
      yield s.enter(_core.Tag.push, Kit.Subst);
      for (var j of decls) {
        if (j.leave && j.type === _core.Tag.VariableDeclarator) {
          yield* s.toks(_core.Tag.init, txt);
        }
        yield j;
      }
    } else {
      yield s.enter(_core.Tag.push, _core.Tag.ExpressionStatement);
      yield s.enter(_core.Tag.expression, _core.Tag.AssignmentExpression, { node: { operator: "=" } });
      yield s.enter(_core.Tag.left, Kit.Subst);
      yield* decls;
      yield* s.leave();
      yield* s.toks(_core.Tag.right, txt);
      yield* s.leave();
    }
    yield* s.leave();
  }
  function* walk(label) {
    for (var i of s.sub()) {
      switch (i.type) {
        case Match.Root:
          if (i.enter) {
            Kit.skip(s.till(v => v.enter && v.type === Match.Placeholder));
            var decls = [].concat(_toConsumableArray(s.sub()));
            Kit.skip(s.till(v => v.enter && v.type === Match.Placeholder));
            var init = [].concat(_toConsumableArray(s.sub()));
            Kit.skip(s.till(v => v.enter && v.type === Match.Placeholder));
            var blab = s.label();
            var body = [].concat(_toConsumableArray(Kit.inBlockBody(s, walk())));
            Kit.skip(s.till(v => v.leave && v.type === Match.Root));
            var _lab = s.label();
            s.template(_core.Tag.push, `
             {
               const _e = $$;
               const _arr = e$y$arr(_e);
               if (_arr != null) {
                  const _len = _arr.length;
                  $$: for(let _i = 0; _i < _len; ++_i) {
                    $$;
                    $$;
                  }
               } else {
                 const _iter = _e[Symbol.iterator]()
                 $$: for(let _i = _iter.next(); !_i.done; _i = _iter.next()) {
                   $$;
                   $$;
                 }
               }
             }`);
            yield* s.open();
            yield s.enter(_core.Tag.init, Kit.Subst);
            yield* init;
            yield* s.leave();
            yield* s.open();
            yield s.tok(_core.Tag.label, label == null ? _core.Tag.Null : T.identifier(label));
            yield* s.open();
            yield* walkDecls(decls, "=_arr[_i]");
            yield* s.open();
            yield* body;
            yield* s.open();
            yield s.tok(_core.Tag.label, label == null ? _core.Tag.Null : T.identifier(label));
            yield* s.open();
            yield* walkDecls([].concat(_toConsumableArray(Kit.clone(decls))), "=_i.value");
            yield* s.open();
            yield* Kit.clone(body);
            yield* _lab();
          }
          continue;
        case _core.Tag.LabeledStatement:
          var lab = s.label();
          var buf = [s.peel(i)].concat(_toConsumableArray(s.one()));
          if (s.cur().type === Match.Root) {
            yield* walk(i.value.node.label.name);
            Kit.skip(lab());
          } else {
            yield* buf;
            yield* walk();
            yield* lab();
          }
          continue;
      }
      yield i;
    }
  }
  return walk();
}, function removeEmptyLabels(si) {
  var s = Kit.auto(si);
  function* walk() {
    for (var i of s.sub()) {
      if (i.enter && i.type === _core.Tag.LabeledStatement && s.cur().type === _core.Tag.Null) {
        s.peel(i);
        Kit.skip(s.one());
        yield s.enter(i.pos, Kit.Subst);
        yield* walk();
        yield* s.leave();
        Kit.skip(s.leave());
        continue;
      }
      yield i;
    }
  }
  return walk();
}, Kit.completeSubst);